--- Portfile.orig	2018-07-20 15:24:11.000000000 -0700
+++ Portfile	2018-07-20 15:28:34.000000000 -0700
@@ -1145,77 +1145,84 @@
     
     long_description        ${description}
     
-    variant postgresql82 conflicts postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 8.2 libraries} {
+    variant postgresql82 conflicts postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 8.2 libraries} {
         depends_lib-append      port:postgresql82
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql82/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql82/bin
     }
     
-    variant postgresql83 conflicts postgresql82 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 8.3 libraries} {
+    variant postgresql83 conflicts postgresql82 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 8.3 libraries} {
         depends_lib-append      port:postgresql83
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql83/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql83/bin
     }
     
-    variant postgresql84 conflicts postgresql82 postgresql83 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 8.4 libraries} {
+    variant postgresql84 conflicts postgresql82 postgresql83 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 8.4 libraries} {
         depends_lib-append      port:postgresql84
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql84/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql84/bin
     }
     
-    variant postgresql90 conflicts postgresql82 postgresql83 postgresql84 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 9.0 libraries} {
+    variant postgresql90 conflicts postgresql82 postgresql83 postgresql84 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 9.0 libraries} {
         depends_lib-append      port:postgresql90
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql90/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql90/bin
     }
     
-    variant postgresql91 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 9.1 libraries} {
+    variant postgresql91 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 9.1 libraries} {
         depends_lib-append      port:postgresql91
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql91/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql91/bin
     }
     
-    variant postgresql92 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 9.2 libraries} {
+    variant postgresql92 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql93 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 9.2 libraries} {
         depends_lib-append      port:postgresql92
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql92/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql92/bin
     }
     
-    variant postgresql93 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 9.3 libraries} {
+    variant postgresql93 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql94 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 9.3 libraries} {
         depends_lib-append      port:postgresql93
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql93/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql93/bin
     }
     
-    variant postgresql94 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql95 postgresql96 description {Use PostgreSQL 9.4 libraries} {
+    variant postgresql94 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql95 postgresql96 postgresql10 description {Use PostgreSQL 9.4 libraries} {
         depends_lib-append      port:postgresql94
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql94/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql94/bin
     }
     
-    variant postgresql95 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql96 description {Use PostgreSQL 9.5 libraries} {
+    variant postgresql95 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql96 postgresql10 description {Use PostgreSQL 9.5 libraries} {
         depends_lib-append      port:postgresql95
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql95/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql95/bin
     }
     
-    variant postgresql96 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 description {Use PostgreSQL 9.6 libraries} {
+    variant postgresql96 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql10 description {Use PostgreSQL 9.6 libraries} {
         depends_lib-append      port:postgresql96
         
         configure.args-append   --with-pgsql=${prefix}/lib/postgresql96/bin \
                                 --with-pdo-pgsql=${prefix}/lib/postgresql96/bin
     }
     
-    if {![variant_isset postgresql82] && ![variant_isset postgresql83] && ![variant_isset postgresql84] && ![variant_isset postgresql90] && ![variant_isset postgresql91] && ![variant_isset postgresql92] && ![variant_isset postgresql93] && ![variant_isset postgresql94] && ![variant_isset postgresql95] && ![variant_isset postgresql96]} {
+    variant postgresql10 conflicts postgresql82 postgresql83 postgresql84 postgresql90 postgresql91 postgresql92 postgresql93 postgresql94 postgresql95 postgresql96 description {Use PostgreSQL 10.0 libraries} {
+        depends_lib-append      port:postgresql10
+        
+        configure.args-append   --with-pgsql=${prefix}/lib/postgresql10/bin \
+                                --with-pdo-pgsql=${prefix}/lib/postgresql10/bin
+    }
+    
+    if {![variant_isset postgresql82] && ![variant_isset postgresql83] && ![variant_isset postgresql84] && ![variant_isset postgresql90] && ![variant_isset postgresql91] && ![variant_isset postgresql92] && ![variant_isset postgresql93] && ![variant_isset postgresql94] && ![variant_isset postgresql95] && ![variant_isset postgresql96] && ![variant_isset postgresql10]} {
         default_variants +postgresql96
     }
 }