diff -ur csl.orig/cslbase/configure csl/cslbase/configure
--- csl.orig/cslbase/configure	2017-12-14 11:47:55.000000000 -0600
+++ csl/cslbase/configure	2018-12-18 21:41:11.000000000 -0600
@@ -4639,7 +4639,7 @@
 # that arise because they hand down options that lead to failures in
 # compilation of any sort at all are then THEIR job to resolve by providing
 # settings that are satisfactory.
-  CPPFLAGS="$CPPFLAGS -I/opt/local/include -I/opt/local/include/freetype2"
+  CPPFLAGS="$CPPFLAGS -I@PREFIX@/include -I@PREFIX@/include/freetype2"
   XLIBS="-lXext -lX11 -lXft -lfontconfig"
   macintosh_build="yes"
   darwin_build="yes"
@@ -24664,7 +24664,7 @@
 # configured for use without a GUI.
   if test "x$with_gui" = "xyes"
   then
-    LL=/opt/local/lib
+    LL=@PREFIX@/lib
     LIBS="$LL/libXrandr.a \
       $LL/libXcursor.a \
       $LL/libXrender.a \
diff -ur csl.orig/cslbase/configure.ac csl/cslbase/configure.ac
--- csl.orig/cslbase/configure.ac	2018-09-25 15:26:06.000000000 -0500
+++ csl/cslbase/configure.ac	2018-12-18 21:45:03.000000000 -0600
@@ -432,7 +432,7 @@
 # that arise because they hand down options that lead to failures in
 # compilation of any sort at all are then THEIR job to resolve by providing
 # settings that are satisfactory.
-  CPPFLAGS="$CPPFLAGS -I/opt/local/include -I/opt/local/include/freetype2"
+  CPPFLAGS="$CPPFLAGS -I@PREFIX@/include -I@PREFIX@/include/freetype2"
   XLIBS="-lXext -lX11 -lXft -lfontconfig"
   macintosh_build="yes"
   darwin_build="yes"
@@ -454,7 +454,7 @@
     CPPFLAGS="$CPPFLAGS -fno-common -I/usr/X11R6/include"
     DLL_CFLAGS="$CFLAGS -bundle -undefined suppress"
     AC_DEFINE(UNIX,[1],[True if we are running on Unix, Linux, BSD etc])
-    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L/opt/local/lib -L/opt/X11/lib"
+    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L@PREFIX@/lib -L/opt/X11/lib"
     LDFLAGS="$LDFLAGS -framework Carbon -framework CoreServices -framework ApplicationServices"
   fi
   AC_CHECK_PROGS(REZ,[/usr/bin/Rez /Developer/tools/Rez],[Rez])
@@ -1552,7 +1552,7 @@
 # configured for use without a GUI.
   if test "x$with_gui" = "xyes"
   then
-    LL=/opt/local/lib
+    LL=@PREFIX@/lib
     LIBS="$LL/libXrandr.a \
       $LL/libXcursor.a \
       $LL/libXrender.a \
@@ -1582,7 +1582,7 @@
   else
 # This is to try to force linking against a system-provided version.
     LDFLAGS="-L/usr/lib -lcurses $LDFLAGS"
-    LL=/opt/local/lib
+    LL=@PREFIX@/lib
     LIBS="$LL/libz.a \
       $LL/libbz2.a \
       $LL/libiconv.a \
diff -ur csl.orig/fox/configure csl/fox/configure
--- csl.orig/fox/configure	2017-12-14 11:47:55.000000000 -0600
+++ csl/fox/configure	2018-12-18 21:36:59.000000000 -0600
@@ -6139,7 +6139,7 @@
   *darwin*)
 # Ugh! With macports the autoconf recipe that establishes X11 paths
 # fails to include this one but it is needed!
-    CXXFLAGS="$CXXFLAGS -I/opt/local/include/freetype2"
+    CXXFLAGS="$CXXFLAGS -I@PREFIX@/include/freetype2"
   ;;
   *mingw32*)
     { $as_echo "$as_me:${as_lineno-$LINENO}: host_os=$host_os so building for native Windows" >&5
diff -ur csl.orig/fox/configure.ac csl/fox/configure.ac
--- csl.orig/fox/configure.ac	2018-06-17 14:20:00.000000000 -0500
+++ csl/fox/configure.ac	2018-12-18 21:36:10.000000000 -0600
@@ -88,7 +88,7 @@
   *darwin*)
 # Ugh! With macports the autoconf recipe that establishes X11 paths
 # fails to include this one but it is needed!
-    CXXFLAGS="$CXXFLAGS -I/opt/local/include/freetype2"
+    CXXFLAGS="$CXXFLAGS -I@PREFIX@/include/freetype2"
   ;;
   *mingw32*)
     AC_MSG_NOTICE([host_os=$host_os so building for native Windows])
diff -ur csl.orig/foxtests/configure csl/foxtests/configure
--- csl.orig/foxtests/configure	2016-01-15 16:38:25.000000000 -0600
+++ csl/foxtests/configure	2018-12-18 21:35:10.000000000 -0600
@@ -3908,7 +3908,7 @@
 
 $as_echo "#define UNIX 1" >>confdefs.h
 
-    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L/opt/local/lib -L/opt/X11/lib"
+    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L@PREFIX@/lib -L/opt/X11/lib"
     LDFLAGS="$LDFLAGS -framework Carbon -framework CoreServices -framework ApplicationServices"
   fi
   ;;
diff -ur csl.orig/foxtests/configure.ac csl/foxtests/configure.ac
--- csl.orig/foxtests/configure.ac	2016-01-23 04:59:11.000000000 -0600
+++ csl/foxtests/configure.ac	2018-12-18 21:34:29.000000000 -0600
@@ -212,7 +212,7 @@
     CPPFLAGS="$CPPFLAGS -fno-common -I/usr/X11R6/include"
     DLL_CFLAGS="$CFLAGS -bundle -undefined suppress"
     AC_DEFINE(UNIX,[1],[True if we are running on Unix, Linux, BSD etc])
-    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L/opt/local/lib -L/opt/X11/lib"
+    LDFLAGS="$LDFLAGS -L/usr/X11R6/lib -L@PREFIX@/lib -L/opt/X11/lib"
     LDFLAGS="$LDFLAGS -framework Carbon -framework CoreServices -framework ApplicationServices"
   fi
   ;;